

# see this link : https://medium.com/swlh/make-your-raspberry-pi-file-system-read-only-raspbian-buster-c558694de79

SCRIPT_DIR="$( cd "$( dirname "${0}" )" >/dev/null 2>&1 && pwd )"


sudo apt remove -y --purge triggerhappy logrotate dphys-swapfile
sudo apt autoremove -y --purge

sudo sed -i "s/fastboot.*/fastboot ro/g" /boot/cmdline.txt

# adds ro/rw commands an propmt indication of which mode is currently set
sudo bash -c "cat ${SCRIPT_DIR}/bashrc-ro-stuff.txt >> /etc/bash.bashrc"

# delete some directories and relink them to tmpfs entries
sudo rm -rf /var/lib/dhcp /var/lib/dhcpcd5 /var/spool /etc/resolv.conf

sudo ln -s /tmp /var/lib/dhcp
sudo ln -s /tmp /var/lib/dhcpcd5
sudo ln -s /tmp /var/spool
sudo touch /tmp/dhcpcd.resolv.conf
sudo ln -s /tmp/dhcpcd.resolv.conf /etc/resolv.conf

# add random-seed support
sudo rm /var/lib/systemd/random-seed
sudo ln -s /tmp/random-seed /var/lib/systemd/random-seed

# this adds the necessary random-seed file (?) on service start
sudo echo  "ExecStartPre=/bin/echo "" >/tmp/random-seed" | sudo tee -a /lib/systemd/system/systemd-random-seed.service

# this should fix the timesyncd service not working
sudo sed -i "s/PrivateTmp=yes/PrivateTmp=no/g" /lib/systemd/system/systemd-timesyncd.service

#these append 'ro' to the according lines in fstab
sudo sed -i "s/ext4 \+defaults,noatime /ext4    defaults,noatime,ro /g"  /etc/fstab
sudo sed -i "s/vfat \+defaults /vfat    defaults,ro /g"  /etc/fstab

# append tmpfs entries to fstab
sudo echo  "tmpfs        /tmp            tmpfs   nosuid,nodev         0       0" | sudo tee -a /etc/fstab
sudo echo  "tmpfs        /var/log        tmpfs   nosuid,nodev         0       0" | sudo tee -a /etc/fstab
sudo echo  "tmpfs        /var/tmp        tmpfs   nosuid,nodev         0       0" | sudo tee -a /etc/fstab

